<?php
class FrmMolliePaymentSettings{

    var $settings;

    function __construct(){
        $this->set_default_options();
    }
    
    function default_options(){
        $siteurl = get_option('siteurl');
        return array(
            'mollie_environment'  => 'test',
            'mollie_email'        => get_option('admin_email'),
            'mollie_currency'     => 'EUR',
            'mollie_return_page'  => '',
            'mollie_cancel_page'  => '',
            'mollie_live_key'     => '',
            'mollie_test_key'     => '',
            'mollie_log'          => true,
            'mollie_log_file'     => '/log/ipn_results.log'
        );
    }
    

    function set_default_options($settings=false){
        $default_settings = $this->default_options();
        
        if ( $settings === true ) {
            $settings = new stdClass();
        } else if ( !$settings ) {
            $settings = $this->get_options();
        }
            
        if ( !isset($this->settings) ) {
            $this->settings = new stdClass();
        }
        
        foreach ( $default_settings as $setting => $default ) {
            if ( is_object($settings) && isset($settings->{$setting}) ) {
                $this->settings->{$setting} = $settings->{$setting};
            }
                
            if ( !isset($this->settings->{$setting}) ) {
                $this->settings->{$setting} = $default;
            }

            if ( 'mollie_log_file' == $setting ) {
                $this->settings->{$setting} = stripslashes($this->settings->{$setting});
            }
        }
        
        if ( $this->settings->mollie_log_file == '.ipn_results.log' ) {
            $this->settings->mollie_log_file = $default_settings['mollie_log_file'];
        }
        
        $this->settings = apply_filters('frm_mollie_settings', $this->settings);
    }
    
    function get_options(){
        $settings = get_option('frm_mollie_options');

        if(!is_object($settings)){
            if($settings){ //workaround for W3 total cache conflict
                $settings = unserialize(serialize($settings));
            }else{
                // If unserializing didn't work
                if(!is_object($settings)){
                    if($settings) //workaround for W3 total cache conflict
                        $settings = unserialize(serialize($settings));
                    else
                        $settings = $this->set_default_options(true);
                    $this->store();
                }
            }
        }else{
            $this->set_default_options($settings); 
        }
        
        return $this->settings;
    }

    function validate($params,$errors){
        if(empty($params[ 'frm_pay_mollie_email' ]) or !is_email($params[ 'frm_pay_mollie_email' ]))
            $errors[] = __('Please enter a valid email address', 'frmppTW');
        return $errors;
    }

    function update($params){
        $settings = $this->default_options();
        
        foreach($settings as $setting => $default){
            if ( ! isset($params['frm_pay_'. $setting]) ) {
                continue;
            }
            if ( 'mollie_log_file' == $setting ) {
                // allow for Windows paths
                $this->settings->{$setting} = addslashes($params['frm_pay_'. $setting]);
            } else {
                $this->settings->{$setting} = $params['frm_pay_'. $setting];
            }
        }     
        
        $this->settings->mollie_log = isset($params['frm_pay_mollie_log']) ? $params['frm_pay_mollie_log'] : 0;
    }

    function store(){
        // Save the posted value in the database
        update_option( 'frm_mollie_options', $this->settings);
    }
  
}
